



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>android中获取root权限的方法以及原理（转）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">android中获取root权限的方法以及原理（转）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 08:31:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一、 概述</p>
<p>本文介绍了android中获取root权限的方法以及原理，让大家对android 玩家中常说的&ldquo;越狱&rdquo;有一个更深层次的认识。</p>
<p>二、 Root 的介绍</p>
<p>1. Root 的目的</p>
<p>可以让我们拥有掌控手机系统的权限，比如删除一些system/app下面的无用软件，更换开关机铃声和动画，拦截状态栏弹出的广告等。</p>
<p>2. Root的原理介绍</p>
<p>谷歌的android系统管理员用户就叫做root，该帐户拥有整个系统至高无上的权利，它可以访问和修改你手机几乎所有的文件，只有root才具备最高级别的管理权限。我们root手机的过程也就是获得手机最高使用权限的过程。同时为了防止不良软件也取得root用户的权限，当我们在root的过程中，还会给系统装一个程序，用来作为运行提示，由用户来决定，是否给予最高权限。这个程序的名字叫做Superuser.apk。当某些程序执行su指令想取得系统最高权限的时候，Superuser就会自动启动，拦截该动作并作出询问，当用户认为该程序可以安全使用的时候，那么我们就选择允许，否则，可以禁止该程序继续取得最高权限。Root的过程其实就是把su文件放到/system/bin/ Superuser.apk 放到system/app下面，还需要设置/system/bin/su可以让任意用户可运行，有set uid和set gid的权限。即要在android机器上运行命令：adb shell chmod 4755 /system/bin/su。而通常，厂商是不会允许我们随便这么去做的，我们就需要利用操作系统的各种漏洞，来完成这个过程。</p>
<p>特别说明：我们烧机中的Eng版本并没有Root权限</p>
<p>3. Root的方法</p>
<p>从Root的原理我们了解到，root 过程分三步：</p>
<p>a. adb push su /system/bin</p>
<p>b. adb push SuperUser.apk /system/app</p>
<p>c. adb shell chmod 4755 /system/bin/su</p>
<p>若系统是eng版的，做到以上三步，那么我们Root就大功告成，但实际是不行的。为什么呢？原因有三：</p>
<p>1、user版的/system路径是只读权限，不能简单写入</p>
<p>2、 chmod需要Root权才能运行（死循环了）</p>
<p>3、有些系统在启动时会自动将su的4755权限设成755，甚至直接删除su</p>
<p>那么针对这种情况，我们怎么办呢？非常简单：烧一个eng版本的boot.img就行了</p>
<p>可以用展讯的烧录工具，或者用fastboot模式从sd卡烧一个boot.img文件即可</p>
<p>至此，我们Root就成功了，可以用R.E(Root Explorer)在根目录创建和删除文件。</p>
<p>三、 深入理解Root机制</p>
<p>其流程是：</p>
<p>1. Su 被用户调用</p>
<p>2. Su 创建了一个socket监听</p>
<p>3. Su 向Superuser发送了一个广播，说是有一个程序要请求root</p>
<p>4. Su 等待socket 数据接收。有超时处理。</p>
<p>5. Superuser 界面收到广播后，弹出一个对话框，询问用户</p>
<p>6. Superuser 向传来的数据中的socket写回用户应答结果。</p>
<p>7. Su 根据socket得到的结果处理应该不应该继续执行</p>
<p>8. 完成提权管理</p>
<p>superuser.apk这个程序是root成功后，专门用来管理root权限使用的，防止被恶意程序滥用。</p>
<p>源码地址：&nbsp;<a href="http://superuser.googlecode.com/svn/trunk" rel="external nofollow noreferrer">http://superuser.googlecode.com/svn/trunk</a></p>
<p>我们有两点疑问：</p>
<p>1. superuser是怎么知道谁想用root权限？</p>
<p>2. superuser是如何把用户的选择告诉su程序的？</p>
<p>即superuser和su程序是如何通讯的，他们俩位于不通的时空，一个在java虚拟中，一个在linux的真实进程中。</p>
<p>superuser共有两个activity: SuperuserActivity 和 SuperuserRequestActivity ，其中SuperuserActivity 主要是用来管理白名单的，就是记住哪个程序已经被允许使用root权限了，省的每次用时都问用户。</p>
<p>SuperuserRequestActivity 就是用来询问用户目前有个程序想使用root权限，是否允许，是否一直允许，即放入白名单。</p>
<p>这个白名单比较关键，是一个sqlite数据库文件，位置：</p>
<p>/data/data/com.koushikdutta.superuser/databases/superuser.sqlite</p>
<p>上文说过，root的本质就是往 /system/bin/ 下放一个su文件，不检查调用者权限的su文件。普通程序可以调用该su来运行root权限的命令。superuser.apk中就自带了一个这样的su程序。一开始superuser会检测/system/bin/su是否存在:</p>
<p>File su = new File("/system/bin/su");</p>
<p>// 检测su文件是否存在,如果不存在则直接返回</p>
<p>if (!su.exists()) {</p>
<p>Toast toast = Toast.makeText(this, "Unable to find /system/bin/su.", Toast.LENGTH_LONG);</p>
<p>toast.show();</p>
<p>return;</p>
<p>}</p>
<p>//如果大小一样，则认为su文件正确，直接返回了事。</p>
<p>if (su.length() == suStream.available())</p>
<p>{</p>
<p>suStream.close();</p>
<p>return; //</p>
<p>}</p>
<p>// 如果检测到/system/bin/su 文件存在，但是不对头，则把自带的su先写到"/data/data/com.koushikdutta.superuser/su"</p>
<p>//再写到/system/bin/su。</p>
<p>byte[] bytes = new byte[suStream.available()];</p>
<p>DataInputStream dis = new DataInputStream(suStream);</p>
<p>dis.readFully(bytes);</p>
<p>FileOutputStream suOutStream = new FileOutputStream("/data/data/com.koushikdutta.superuser/su");</p>
<p>suOutStream.write(bytes);</p>
<p>suOutStream.close();</p>
<p>Process process = Runtime.getRuntime().exec("su");</p>
<p>DataOutputStream os = new DataOutputStream(process.getOutputStream());</p>
<p>os.writeBytes("mount -oremount,rw /dev/block/mtdblock3 /system\n");</p>
<p>os.writeBytes("busybox cp /data/data/com.koushikdutta.superuser/su /system/bin/su\n");</p>
<p>os.writeBytes("busybox chown 0:0 /system/bin/su\n");</p>
<p>os.writeBytes("chmod 4755 /system/bin/su\n");</p>
<p>os.writeBytes("exit\n");</p>
<p>os.flush();</p>
<p>有进程使用root权限，superuser是怎么知道的呢，关键是句：</p>
<p>sprintf(sysCmd, "am start -a android.intent.action.MAIN</p>
<p>-n com.koushikdutta.superuser/com.koushikdutta.superuser.SuperuserRequestActivity</p>
<p>--ei uid %d --ei pid %d &gt; /dev/null", g_puid, ppid);</p>
<p>if (system(sysCmd))</p>
<p>return executionFailure("am.");</p>
<p>原理是am命令，am的用法：</p>
<div>
<pre class="prettyprint linenums">  usage: am [subcommand] [options]<br />
    start an Activity: am start [-D] [-W] &lt;INTENT&gt;<br />
        -D: enable debugging<br />
        -W: wait for launch to complete<br />
    start a Service: am startservice &lt;INTENT&gt;<br />
    send a broadcast Intent: am broadcast &lt;INTENT&gt;<br />
    start an Instrumentation: am instrument [flags] &lt;COMPONENT&gt;<br />
        -r: print raw results (otherwise decode REPORT_KEY_STREAMRESULT)<br />
        -e &lt;NAME&gt; &lt;VALUE&gt;: set argument &lt;NAME&gt; to &lt;VALUE&gt;<br />
        -p &lt;FILE&gt;: write profiling data to &lt;FILE&gt;<br />
        -w: wait for instrumentation to finish before returning<br />
    start profiling: am profile &lt;PROCESS&gt; start &lt;FILE&gt;<br />
    stop profiling: am profile &lt;PROCESS&gt; stop<br />
    &lt;INTENT&gt; specifications include these flags:<br />
        [-a &lt;ACTION&gt;] [-d &lt;DATA_URI&gt;] [-t &lt;MIME_TYPE&gt;]<br />
        [-c &lt;CATEGORY&gt; [-c &lt;CATEGORY&gt;] ...]<br />
        [-e|--es &lt;EXTRA_KEY&gt; &lt;EXTRA_STRING_VALUE&gt; ...]<br />
        [--esn &lt;EXTRA_KEY&gt; ...]<br />
        [--ez &lt;EXTRA_KEY&gt; &lt;EXTRA_BOOLEAN_VALUE&gt; ...]<br />
        [-e|--ei &lt;EXTRA_KEY&gt; &lt;EXTRA_INT_VALUE&gt; ...]<br />
        [-n &lt;COMPONENT&gt;] [-f &lt;FLAGS&gt;]<br />
        [--grant-read-uri-permission] [--grant-write-uri-permission]<br />
        [--debug-log-resolution]<br />
        [--activity-brought-to-front] [--activity-clear-top]<br />
        [--activity-clear-when-task-reset] [--activity-exclude-from-recents]<br />
        [--activity-launched-from-history] [--activity-multiple-task]<br />
        [--activity-no-animation] [--activity-no-history]<br />
        [--activity-no-user-action] [--activity-previous-is-top]<br />
        [--activity-reorder-to-front] [--activity-reset-task-if-needed]<br />
        [--activity-single-top]<br />
        [--receiver-registered-only] [--receiver-replace-pending]<br />
        [&lt;URI&gt;]</pre>
</div>
<p>还有个疑点，就是su怎么知道用户是允许root权限还是反对呢？原来是上面提到的白名单起来作用，superuser把用户的选择放入：<br />/data/data/com.koushikdutta.superuser/databases/superuser.sqlite&nbsp; &nbsp; 数据库中，然后su进程再去读该数据库来判断是否允许。</p>
<p>}<br />四、 资源文件的获取<br />从上文的源码地址获取源代码，替换系统的system/extras/su/下面的su.c 和Android.mk文件，使用编译命令 ./mk td28 u adr system/extras/su/ 编译成功后会生成out/target/product/hsdroid/system/xbin/su 文件，而Superuser.apk就是普通的apk文件，都在源码地址里面可以下载，下载后倒入到eclipse即可直接运行。<br />五、 总结<br />在阅读完本文后，可以站在专业的角度了解root的真正原理，以及有用户有需求时我们可以帮助其快速的解决问题。</p>
<p><a href="http://www.cnhonkerarmy.com/thread-154472-1-1.html?jdfwkey=nx1xo2" rel="external nofollow noreferrer">http://www.cnhonkerarmy.com/thread-154472-1-1.html?jdfwkey=nx1xo2</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1rpv68.html">&lbrack;nRF51822&rsqb; 13、浅谈nRF51822和NRF24LE1&sol;NRF24LU1&sol;NRF24L01经典2&period;4G模块无线通信配置与流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o6z6x8.html">&lbrack;转&rsqb;轻松解决oracle11g 空表不能exp导出的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g2v308.html">腾讯云CentOS7安装LNMP&plus;wordpress</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mj5x9.html">Dynamic view</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y6n25q.html">Javascript中new</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05454q.html">Python与MySQL首次交互</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdjwze8.html">SQL Server 储存过程的output 参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1ygogq.html">基于Asterisk的VoIP开发指南&mdash;&mdash;&lpar;1&rpar;实现基本呼叫功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/950jnjv8.html">ps-抠图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjkyvj8.html">SpringBoot项目在IntelliJ IDEA中实现热部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj74z38.html">&lbrack;PHP&rsqb; 工厂模式的日常使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyg0wv9.html">SQL-56 获取所有员工的emp&lowbar;no、部门编号dept&lowbar;no以及对应的bonus类型btype和recevied，没有分配具体的员工不显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllx57xq.html">&period;net   服务端     访问共享文件夹</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj6l139.html">Apktool编译找不到&OpenCurlyDoubleQuote;keyboardNavigationCluster&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvy1wl8.html">50A</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdvozz9.html">Linux&colon;【解决】无法连接 MKS&colon;套接字连接尝试次数太多正在放弃</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7orn0x8.html">mysql主从复制-读写分离</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1yvx49.html">jQuery显示SQL存储过程自定义异常信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/9630o3n9.html">Python学习笔记&lowbar;04&colon;Django框架简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj24n28.html">excel中对数据进行分类求和</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qydp5pxq.html">Android EditText屏蔽默认长按粘贴复制事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn13wyk8.html">Android Studio 没有assets目录的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x6d668.html">存储、读取&mdash;&mdash;Android应用程序内置的文件夹</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x6zg08.html">mysql性能优化学习笔记（3）常见sql语句优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wrgoxq.html">C语言中内存分配 &lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydpoegq.html">logstash 根据type 判断输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok7oke9.html">Ubuntu下QT控制台程序无法运行的解决方案以及XTerm的配置方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdo3k48.html">java快速排序1000万无序数组JVM-Xmx&equals;256M 耗时2s</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o1k4y9.html">POJ 1135 Domino Effect （spfa &plus; 枚举）- from lanshui&lowbar;Yang</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok7p1e9.html">Controller中获取输入参数注解使用总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
